#!/bin/bash
# alexnihilo / sept - 2007
# AbreCiré / sept-Oct-Nov-Dec - 2007
# contributeur did
KoovRelease="beta 1.0.7"
# Assigner une image comme icone du dossier 
# En tant que root, créer un fichier nommé KoovFolder.sh dans /usr/local/bin/
# puis rendre ce fichier exécutable (#chmod 755 /usr/local/bin/KoovFolder.sh) 

 ### BUG: Avec gif animé (autant de fichiers créés que d'étapes d'animations)
 #        Suppression des gif dans le choix automatique du mode récursif
 #        Voir possibilité d'utiliser ImageMagick pour identifier les gif annimés.

# TODO: Si icône folder.png non trouvée, afficher une alerte kdialog !
# TODO: Lire les variables forcées depuis un fichier
# TODO: Forcer le rafraichissement du cache d'icônes après un traitement Koov
# TODO: améliorer modes d'affichages possibles
# TODO: Gérer le mode récursif en graphique aussi (via kdialog)
# TODO: Gérer le logfile (en cours ...)
# TODO: Gérer le mode simulate

# ================================================================================================= Changelog
# Changelog
# =========
# KoovRelease Beta 1.0.7
# Ajout de la fonction READ_CONF

# KoovRelease Beta 1.0.6
# Première diffusion



 ### ============================================================================================= Fonction PAUSE DEBUG
pause_debug ()
{
echo "Pause - Debug.   C Continuer / Q Quitter"
read CorQ
case $CorQ in
"C"|"c" )
	echo "on continue !"
	;;
"Q"|"q" )
	clear
	exit 0
	;;
esac
}

# ================================================================================================= Fonction Aide
HELP_SECTION ()
{
	clear
	echo ""
	echo ""
	echo ""
	echo "KoovFolder [Options] [Traitement] [Image]"
	echo "                     : Applique le traitemenent choisi à l'image sélectionnée et"
	echo "                       l'affecte à l'icône du répertoire courant."
	echo ""
	echo "KoovFolder [Options] [Traitements] [répertoire]"
	echo "                     : Applique le traitemenent choisi à tous les répertoires contenant"
	echo "                       une image. l'image trouvée par le script est affectée à l'icône du"
	echo "                       répertoire la contenant."
	echo ""
	echo "Les Options :"
	echo "-------------"
	echo "    -H  | --help     : Affiche l'aide en ligne"
	echo ""
	echo "    -R  | --recurse  : Active le mode récursif"
	echo "                       En mode récursif, toute une arborescence de répertoires"
	echo "                       est traitée en une seule fois."
	echo ""
	echo "    -L  | --log      : Ecrit un fichier log (pas encore disponible en console)"
	echo ""
	echo "    -S  | --simulate : Ecrit un fichier log sans effectuer les actions (pas encore disponible)"
	echo "                       En mode récursif uniquement"
	echo ""
	echo "Les Traitements :"
	echo "-----------------"
	echo "    IAI  |  ImageAsIcon     : Une  copie de l'image en 128x128"
	echo ""
	echo "    IOF  |  ImageOverFolder : une miniature de l'image superposée au dossier par défaut"
	echo ""
	echo "    FOI  |  FolderOverImage : une miniature du dossier par défaut superposée à l'image"
	echo ""
	echo "    FS   |  FolderShadow    : l'image est plaquée sur le contour du dossier par défaut"
	echo ""
	echo "    P    |  Polaroid        : L'image est tranformée en photo, type Polaroid"
	echo ""
	echo "    PS   |  PolaroidStack   : L'image est transformée en une pile de polaroids"
	echo ""
	echo "    STD  |  StandardFolder  : Retour au dossier par défaut"
	echo ""
	echo ""
	echo "Image ou Répertoire :"
	echo "---------------------"
	echo "    Si un nom de fichier image est donné, le répertoire la contenant sera traité."
	echo ""
	echo "    Si un nom de répertoire est donné, une image sera choisie par le script pour le traitement"
	echo "    Dans l'ordre : folder.jpg / cover.png / albumartxxxxx.jpg / albumartxxxxx.png / *.jpg / *.png"
	echo ""
	echo "Divers :"
	echo "--------"
	echo "    L'ordre dans lequel sont passés les arguments n'a pas d'importance"
	echo "    koovfolder.sh -R ImageAsIcon \"Répertoire\" est équivalent à koovfolder.sh \"Répertoire\" -R ImageAsIcon "
	echo ""
	echo "    Pour éviter les problèmes avec les noms d'image ou de répertoire, les entourer de guillemets \" "
	echo "    koovfolder.sh ImageAsIcon \"Nom de répertoire\" "
	echo ""
	echo "Bugs :"
	echo "------"
	echo "    - Avec les gif animés (autant de fichiers que d'étapes d'animations)"
	echo "      Suppression des gif dans le choix automatique du mode récursif, en attendant une solution"
	echo ""
	echo "------------------------------------------"
	echo "alexnihilo / ArbreCiré - Sept 2007"
	echo
	exit 0
}

# ================================================================================================= Fonction Filtrage des arguments
ARGUMENT_FILTERING ()
{
echo "Fonction                     : ARGUMENT_FILTERING"
echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
# Trier les arguments entrés, les affecter aux variables KoovFolder
# Vérifier que le Filtre, l'Image ou le Répertoire sont corrects
# Test de cohérence, message et sortie si Problème

KoovCanAct="True"
GiveHelp="False"

# Affectation des arguments 1 à 4 aux variables du script
case "$Var1" in
"-H" | "--help")
	GiveHelp="True"
	;;
	
"-R" | "--recurse")
	RecurseMode="True"
	;;
	
"-L" | "--log")
	LogFile="True"
	;;
	
"-S" | "--simulate")
	SimulateMode="True"
	;;
	
"IAI" | "ImageAsIcon" | "FOI" | "FolderOverImage" | "FS" | "FolderShadow" | "IOF" | "ImageOverFolder" | "P" | "Polaroid" | "PS" | "PolaroidStack" | "STD" | "StandardFolder")
	Filter="$Var1"
	;;
	
"--Svc_menu")
	Launch_type="Service Menu"
	;;
	
* )
	if [[ -z "$InVar" ]]
	then
		InVar="$Var1"
	fi
	;;
	
esac

case "$Var2" in
"-H" | "--help")
	GiveHelp="True"
	;;
	
"-R" | "--recurse")
	RecurseMode="True"
	;;
	
"-L" | "--log")
	LogFile="True"
	;;
	
"-S" | "--simulate")
	SimulateMode="True"
	;;
	
"IAI" | "ImageAsIcon" | "FOI" | "FolderOverImage" | "FS" | "FolderShadow" | "IOF" | "ImageOverFolder" | "P" | "Polaroid" | "PS" | "PolaroidStack" | "STD" | "StandardFolder" )
	Filter="$Var2"
	;;
	
"--Svc_menu")
	Launch_type="Service Menu"
	;;
	
* )
	if [[ -z "$InVar" ]]
	then
	InVar="$Var2"
	fi
	;;
	
esac

case "$Var3" in
"-H" | "--help")
	GiveHelp="True"
	;;
	
"-R" | "--recurse")
	RecurseMode="True"
	;;
	
"-L" | "--log")
	LogFile="True"
	;;
	
"-S" | "--simulate")
	SimulateMode="True"
	;;
	
"IAI" | "ImageAsIcon" | "FOI" | "FolderOverImage" | "FS" | "FolderShadow" | "IOF" | "ImageOverFolder" | "P" | "Polaroid" | "PS" | "PolaroidStack" | "STD" | "StandardFolder")
	Filter="$Var3"
	;;
	
"--Svc_menu")
	Launch_type="Service Menu"
	;;
	
* )
	if [[ -z "$InVar" ]]
	then
	InVar="$Var3"
	fi
	;;
	
esac

case "$Var4" in
"-H" | "--help")
	GiveHelp="True"
	;;
	
"-R" | "--recurse")
	RecurseMode="True"
	;;
	
"-L" | "--log")
	LogFile="True"
	;;
	
"-S" | "--simulate")
	SimulateMode="True"
	;;
	
"IAI" | "ImageAsIcon" | "FOI" | "FolderOverImage" | "FS" | "FolderShadow" | "IOF" | "ImageOverFolder" | "P" | "Polaroid" | "PS" | "PolaroidStack" | "STD" | "StandardFolder")
	Filter="$Var4"
	;;
	
"--Svc_menu")
	Launch_type="Service Menu"
	;;
	
* )
	if [[ -z "$InVar" ]]
	then
	InVar="$Var4"
	fi
	;;
	
esac

case "$Var5" in
"-H" | "--help")
	GiveHelp="True"
	;;
	
"-R" | "--recurse")
	RecurseMode="True"
	;;
	
"-L" | "--log")
	LogFile="True"
	;;
	
"-S" | "--simulate")
	SimulateMode="True"
	;;
	
"IAI" | "ImageAsIcon" | "FOI" | "FolderOverImage" | "FS" | "FolderShadow" | "IOF" | "ImageOverFolder" | "P" | "Polaroid" | "PS" | "PolaroidStack" | "STD" | "StandardFolder")
	Filter="$Var5"
	;;
	
"--Svc_menu")
	Launch_type="Service Menu"
	;;
	
* )
	if [[ -z "$InVar" ]]
	then
	InVar="$Var5"
	fi
	;;
	
esac

case "$Var6" in
"-H" | "--help")
	GiveHelp="True"
	;;
	
"-R" | "--recurse")
	RecurseMode="True"
	;;
	
"-L" | "--log")
	LogFile="True"
	;;
	
"-S" | "--simulate")
	SimulateMode="True"
	;;
	
"IAI" | "ImageAsIcon" | "FOI" | "FolderOverImage" | "FS" | "FolderShadow" | "IOF" | "ImageOverFolder" | "P" | "Polaroid" | "PS" | "PolaroidStack" | "STD" | "StandardFolder")
	Filter="$Var6"
	;;
	
"--Svc_menu")
	Launch_type="Service Menu"
	;;
	
* )
	if [[ -z "$InVar" ]]
	then
	InVar="$Var6"
	fi
	;;
	
esac


# Appel à la fonction aide et sortie
case $GiveHelp in
"True")
	HELP_SECTION
	exit 0
	;;
	
esac

# Test de la validité des arguments, Affectation des variables pour le traitement
if [[ -z "$RecurseMode" ]]
then 
	RecurseMode="False"
else
	RecurseMode="True"
fi

if [[ -z "$LogFile" ]]
then 
	LogFile="False"
else
	LogFile="True"
fi

if [[ -z "$Filter" ]]
then 
	Filter="Filtre inconnu"
	KoovCanAct="False"
else
	if [[ ! "$KoovCanAct"="False" ]]
	then
		KoovCanAct="True"
	fi
fi

if [[ -z "$InVar" ]]
then 
	InVar="Ni image, ni répertoire spécifié"
	KoovCanAct="False"
else
	if [[ ! "$KoovCanAct"="False" ]]
	then
		KoovCanAct="True"
	fi
fi

if [[ -z "$SimulateMode" ]]
then 
	SimulateMode="False"
else
	SimulateMode="True"
fi

if [[ -z "$Launch_type" ]]
then 
	Launch_type="Command Ligne"
else
	Launch_type="Service Menu"
fi

### affichage pour le debug
### ~~~~~~~~~~~~~~~~~~~~~~~
echo "                        Var1 : "$Var1
echo "                        Var2 : "$Var2
echo "                        Var3 : "$Var3
echo "                        Var4 : "$Var4
echo "                        Var5 : "$Var5
echo "                        Var6 : "$Var6
echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
echo "Koov lancé par               : "$Launch_type
echo "Mode recursif                : "$RecurseMode
echo "Creation d'un logfile        : "$LogFile
echo "Type de traitement           : "$Filter
echo "Enrée à analyser             : "$InVar
echo "Mode simulation              : "$SimulateMode
echo "============================="
### ~~~~~~~~~~~~~~~~~~~~~~~


}

# ================================================================================================= Fonction Read Config
READ_CONF ()
{
READ_CONF_Release="Beta 0.0.3"
#lire les variables dans un fichier
Koov_conf_dir=$HOME"/.KoovFolder"
Koov_conf_file=$Koov_conf_dir/"KoovFolder.conf"

echo "Fonction                     : CREATE_CONF Version "$READ_CONF_Release
echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
echo "Répertoire de config         : ""$Koov_conf_dir"

# tester existence du répertoire ~/KoovFolder
	# le créer si besoin
if [[ -d "$Koov_conf_dir" ]]
then
	Koov_conf_dir_check="True"
	echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
	echo "Répertoire trouvé            : "$Koov_conf_dir_check

else
	Koov_conf_dir_check="False"
	echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
	echo "Répertoire trouvé            : "$Koov_conf_dir_check
	echo "Création de                  : "$Koov_conf_dir
	
	mkdir "$Koov_conf_dir"
fi

# Verif création du répertoire
if ls "$Koov_conf_dir" &> /dev/null
then	# code de sortie de ls = 0, commande OK
	Koov_conf_dir_check="True"
else	# code de sortie de ls != 0, commande échouée
	Koov_conf_dir_check="False"
fi
echo "Répertoire accessible        : "$Koov_conf_dir_check


# tester existence du fichier de conf KoovFolder.conf
# Si absent, le créer
if [[ -r "$Koov_conf_file" ]]
then
	Koov_conf_file_check="True"
	echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
	echo "Fichier de config trouvé     : "$Koov_conf_file_check

else
	# Créer $Koov_conf_file
	Koov_conf_file_check="False"
	echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
	echo "Fichier de config trouvé     : "$Koov_conf_file_check
	echo "Création de                  : "$Koov_conf_file
	
	# Remplir $Koov_conf_file avec valeurs par défaut
	touch $Koov_conf_file
	echo '#!/bin/bash'										> $Koov_conf_file
	echo '[KoovFolder Variables]' 									>>  $Koov_conf_file
	echo 												>> $Koov_conf_file
	
	echo '# conf_icon_folder : Répertoire contenant l'\'' icône du dossier par défaut'		>> $Koov_conf_file
	echo '# Pour laisser l'\''outil rechercher le répertoire utiliser la valeur "default" '		>> $Koov_conf_file
	echo '#     conf_icon_folder=default'								>> $Koov_conf_file
	echo '#'											>> $Koov_conf_file
	echo '# Pour forcer l'\''outil à utiliser un thème particulier URL   '				>> $Koov_conf_file
	echo '#     conf_icon_folder=/home/USER/mes_icones/mon_thème'					>> $Koov_conf_file
	echo 												>> $Koov_conf_file
	echo 'conf_icon_folder=default'									>> $Koov_conf_file
	echo 												>> $Koov_conf_file
	echo 												>> $Koov_conf_file
	
	echo '# conf_icon_file : Nom du fichier contenant l'\''icône personnalisée '			>> $Koov_conf_file
	echo '# Par défaut le nom de l'\''icône est .directory.png '					>> $Koov_conf_file
	echo '#     conf_icon_file=.directory.png'							>> $Koov_conf_file
	echo 												>> $Koov_conf_file
	echo 'conf_icon_file=.directory.png'								>> $Koov_conf_file
	echo 												>> $Koov_conf_file
	echo 												>> $Koov_conf_file
	
	echo '# conf_col_depth : Format de travail des outils ImageMagick '				>> $Koov_conf_file
	echo '# Q8 corresponds à 8bits par couleurs (valeur par défaut) '				>> $Koov_conf_file 
	echo '#     soit un fichier 24bits pour Rouge / Vert / Bleu (sans transparence) '		>> $Koov_conf_file
	echo '#     soit un fichier 32bits pour Rouge / Vert / Bleu / Alpha (avec transparence) '	>> $Koov_conf_file
	echo '#'											>> $Koov_conf_file
	echo '# Q16 corresponds à 16bits par couleurs '							>> $Koov_conf_file 
	echo '#     soit un fichier 48bits pour Rouge / Vert / Bleu (sans transparence) '		>> $Koov_conf_file
	echo '#     soit un fichier 64bits pour Rouge / Vert / Bleu / Alpha (avec transparence) '	>> $Koov_conf_file
	echo '#'											>> $Koov_conf_file
	echo '# Les temps de calculs et la taille des fichiers augmentent énormément avec Q16 '		>> $Koov_conf_file
	echo 												>> $Koov_conf_file
	echo 'conf_col_depth=Q8'									>> $Koov_conf_file
	echo '#conf_col_depth=Q16'									>> $Koov_conf_file
	echo 												>> $Koov_conf_file
	echo 												>> $Koov_conf_file
	
	echo '# conf_del_log : Effacement automatique des fichiers log générés par l'\''outil '		>> $Koov_conf_file
	echo '#     conf_del_log=non par défaut '							>> $Koov_conf_file
	echo '#     conf_del_log=oui pour ne plus avoir de question posée en fin de traitement '	>> $Koov_conf_file
	echo 												>> $Koov_conf_file
	echo 'conf_del_log=non'										>> $Koov_conf_file
	echo '#conf_del_log=oui'									>> $Koov_conf_file

fi

# Verif création de $Koov_conf_file
if ls "$Koov_conf_file" &> /dev/null
then	# code de sortie de ls = 0, commande OK
	Koov_conf_file_check="True"
	echo "Fichier de config accessible : "$Koov_conf_file_check
else	# code de sortie de ls != 0, commande échouée
	Koov_conf_file_check="False"
	echo "Fichier de config accessible : "$Koov_conf_file_check
fi

echo "Lecture du fichier de conf   : "$Koov_conf_file
echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
# Si le fichier existe, lire les variables
if [[ -r "$Koov_conf_file" ]]
then
	# lire conf_icon_folder= 
	conf_read_icon_folder=$(cat $Koov_conf_file | sed -n "/^conf_icon_folder=/p" | cut -f2 -d'=' -s)
	echo "Icône de dossier par défaut  : "$conf_read_icon_folder
	
	# lire conf_icon_file= 
	conf_read_icon_file=$(cat $Koov_conf_file | sed -n "/^conf_icon_file=/p" | cut -f2 -d'=' -s)
	echo "Icône de répertoire          : "$conf_read_icon_file

	# lire conf_col_depth= 
	conf_read_col_depth=$(cat $Koov_conf_file | sed -n "/^conf_col_depth=/p" | cut -f2 -d'=' -s)
	echo "Profondeur des couleurs      : "$conf_read_col_depth

	# lire conf_del_log= 
	conf_read_del_log=$(cat $Koov_conf_file | sed -n "/^conf_del_log=/p" | cut -f2 -d'=' -s)
	echo "Effacement auto des logfiles : "$conf_read_del_log

fi



}

# ================================================================================================= Fonction Recherche Icône de dossier
DEFAULT_FOLDER_SEARCHING ()
{
echo "Fonction                     : DEFAULT_FOLDER_SEARCHING"
echo "============================="
### référence de l'icone de dossier standard

# Recherche des répertoires contenant les icônes (merci did !)
# thèmes par défaut de la distrib
# Kubuntu			: /usr/share/icons/default.kde/128x128/filesystems
# OpenSuse			: /opt/kde3/share/icons/default.kde/128x128/filesystems

# Thèmes ajouté en root via gestionaire de paquets
# toutes distrib	:	/usr/share/icons/"$Icon_theme"/128x128/filesystems

# Thèmes ajouté en utilisateur simple via Gestionnaire de thèmes (kcontrol)
# toutes distrib	:	"$HOME"/.kde/share/icons/"$Icon_theme"/128x128/filesystems

# Recherche des path via kde-config, ou répertoire lu en conf
# s'assurer que les répertoires "standards" ont été scannés
case "$Default_folder_icon_path" in
default)
	# Recherche du thème utilisé
	Icon_theme=$(cat $HOME/.kde/share/config/kdeglobals| grep ^Theme= | cut -f2 -d'=' -s)
	echo "Thème                        : "$Icon_theme
	echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"

	Icon_path_check=$(kde-config --path icon | cut -f1 -d':' -s)
	;;
*)
	Icon_theme=
	Icon_path_check="$Default_folder_icon_path"
	;;
esac




Compteur_Boucle=1
while [[ -d "$Icon_path_check" ]]
do
	# Mémoriser le scan des répertoires "standards"
	if [[ "$Icon_path_check" == "/usr/share/icons/" ]]
	then
		usr_share_icons_scan="True"
	else
		usr_share_icons_scan="False"
	fi
	
	# Recherche dans les répertoires de kde-config
	Icon_folder=$Icon_path_check$Icon_theme"/128x128/filesystems/folder.png"
	echo "Chemin                       : "$Icon_path_check
	echo "Icône                        : "$Icon_folder
	
	# Verif $Icon_folder "lisible"
	if [[ -r "$Icon_folder" ]]
	then
		echo "fichier                      : lisible"
		Icon_folder_found="True"
	else
		echo "fichier                      : non trouvé"
		if [[ "$Icon_folder_found" != "True" ]]
		then
			Icon_folder_found="False"
		fi
	fi
	echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
	
	# si Icône trouvée, sortir de la boucle
	if [[ "$Icon_folder_found" == "True" ]]
	then
		ICON_PATH="$Icon_path_check"
		Icon_path_check="Sortie_De_Boucle"
	else
		let "Compteur_Boucle+=1"
		case "$conf_read_icon_folder" in
		default)
			Icon_path_check=$(kde-config --path icon | cut -f$Compteur_Boucle -d':' -s)
			;;
		*)
			Icon_path_check="$Default_folder_icon_path"
			;;
		esac
		
	fi
	
	# Brider la boucle pour éviter les loopings !
	if [[ $Compteur_Boucle == 20 ]]
	then
		echo "Recherche effectuée          : 20 fois"
		echo "fichier                      : non trouvé"
		echo "Vérifier le fichier de config: "$Koov_conf_file
		
		KoovCanAct="False"
		Icon_path_check="Sortie_De_Boucle"
	fi
done


# Si icône de dossier non trouvée,
# Vérif si répertoires "standards" parcourrus 
if [[ "$Icon_folder_found" != "True" ]]
then
	if [[ "$usr_share_icons_scan" == "False" ]]
	then
		Icon_path_check=/usr/share/icons/
		usr_share_icons_scan="True"
		
		Icon_folder=$Icon_path_check$Icon_theme"/128x128/filesystems/folder.png"
		echo "Chemin                       : "$Icon_path_check
		echo "Thème                        : "$Icon_theme
		echo "Icône                        : "$Icon_folder
		
		if [[ -r "$Icon_folder" ]]
		then
			echo "fichier                      : lisible"
			Icon_folder_found="True"
			ICON_PATH="$Icon_path_check"
		else
			echo "fichier                      : non trouvé"
			if [[ "$Icon_folder_found" != "True" ]]
			then
				Icon_folder_found="False"
			fi
		fi
	fi
	
	
	
fi


if [[ "$usr_share_icons_scan" == "True" ]]
then
	echo "/usr/share/icons             : Scanné"
else
	echo "/usr/share/icons             : Non Scanné"
fi
	echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"


echo "Thème d'icônes               : "$Icon_theme

if [[ "$Icon_folder_found" == "True" ]]
then
	icon_folder=$ICON_PATH$Icon_theme"/128x128/filesystems/folder.png"
	echo "Icône de dossier             : "$icon_folder
else
	### TODO Si icône folder.png non trouvée, afficher une alerte kdialog !
	# kdialog 
	# icone non trouvée,
	# renseigner forced_icone ou
	# choisir une autre action
	
	
	
	KoovCanAct="False"
	echo "Icône de dossier             : Non Trouvée "
fi

echo "============================="

}

# ================================================================================================= Fonction Sélection image à traiter
IMAGE_SELECTION ()
{
echo "Fonction                     : IMAGE_SELECTION"
echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"

# On teste si la référence d'une image précise est donnée lors de l'appel au script 
# Sinon, Choix automatique d'une image en respectant certaines préférences
if [[ -f "$InVar" ]]
then
	IMAGE="$InVar"
	echo "Répertoire à traiter         : "$WRKDIR
	echo "Type d'image                 : Image imposée : "$InVar
	echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
	
	KoovAction="True"
	

else
	# =============================================================================
	# Si IMAGE est vide, cherche une image connue
	
	echo "Répertoire à traiter         : "$WRKDIR
	
	# si Traitement StandardFolder, True uniquement si ICON_FILE existe, sinon pas de traitement !
	case $Filter in
	# Traitement StandardFolder, KoovAction True uniquement si $ICON_FILE existe, sinon pas de traitement !
	"STD" | "StandardFolder" )	
		# recherche du fichier $ICON_FILE, s'il existe retour au dossier standard possible
		echo "Searching for                : "$ICON_FILE
		KOOV_ICON_FILE=$(ls "$WRKDIR"/"$ICON_FILE")
		
		### DEBUG
		#	echo "WrkDir     : "$WRKDIR
		#	echo "Icon_File  : "$ICON_FILE
		#	echo "retour ls  : "$KOOV_ICON_FILE
		#	pause_debug
		### FIN DEBUG
		
		#s'il n'y a pas de $ICON_FILE, on prévient, on ne modifie pas l'état du répertoire
		if [[ -z $KOOV_ICON_FILE ]]
		then
			echo "Icône à supprimer            : Pas de fichier "$ICON_FILE" trouvé"
			echo "============================="
			KoovAction="False"
		else
			KoovAction="True"
		fi
		
		echo "Icône à supprimer            : "$KOOV_ICON_FILE
		echo "KoovAction                   : "$KoovAction
		echo "============================="
		
		;;
		
	# Tous les autres traitement, faire la sélection d'image normale
	# pour changer l'ordre dans le choix des fichiers, 
	# déplacer les groupes de lignes "# choix .... if ...  then IMAGE...  fi"
	* )
		echo "Type d'image                 : Choix par le script"
		echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
		
		# choix du fichier folder.jpg s'il existe (icône de dossier pour windows)
		if [[ -z "$IMAGE" ]]
		then	
			echo "Searching for                : folder.jpg"
			IMAGE=`ls "$WRKDIR" | grep -i folder.jpg | head -n 1`
		fi
		
		# choix du fichier cover.png s'il existe (icône d'album amaroK)
		if [[ -z "$IMAGE" ]]
		then
			echo "Searching for                : cover.png"
			IMAGE=`ls "$WRKDIR" | grep -i cover.png | head -n 1`
		fi
		
		# choix du fichier albumartxxxxx.jpg s'il existe (icones de win mediaplayer / iTune / Winammp / etc..  )
		if [[ -z "$IMAGE" ]]
		then
			echo "Searching for                : albumart*.jpg"
			IMAGE=`ls "$WRKDIR" | grep -i ^albumart | grep -i .jpg$ | head -n 1`
		fi
		
		# Si aucune des préférences n'est trouvée, choix de la 1ere image png si elle existe
		if [[ -z "$IMAGE" ]]
		then
			echo "Searching for                : *.png"
			IMAGE=`ls "$WRKDIR" | grep -i .png$ | head -n 1`
		fi
		
		# Si aucune image png n'est trouvée, choix de la 1ere image jpg si elle existe
		if [[ -z "$IMAGE" ]]
		then
			echo "Searching for                : *.jpg"
			IMAGE=`ls "$WRKDIR" | grep -i .jpg$ | head -n 1`
		fi
		
		# Fin de "Choix automatique d'une image"
		# =============================================================================
			
			
		#s'il n'y a pas d'image, on prévient, on ne modifie pas l'état du répertoire
		if [[ -z $IMAGE ]]
		then
			echo "Image à traiter              : Aucun fichier image trouvé"
			echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
			KoovAction="False"
		else
			KoovAction="True"
		fi
		
		echo "Image à traiter              : "$IMAGE
		echo "KoovAction                   : "$KoovAction
		echo "============================="
		
		;;
		
	esac
	
fi

# =================================================================================================


}

# ================================================================================================= Fonction Traitements Graphiques
GRAPHIC_TREATMENTS ()
{
echo "Fonction                     : GRAPHIC_TREATMENTS"
echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"

# Complément de IMAGE pour récursivité
IMAGE="$WRKDIR"/"$IMAGE"
 
# on efface le fichier Icône du dossier s'il existe déjà
# cela aide pour la mise à jour de icône en cas de remplacement.
if [[ $KoovAction="True" ]]
then
	if [[ -f "$WRKDIR"/$ICON_FILE ]]
	then
		rm "$WRKDIR"/$ICON_FILE
	fi
fi


## Selon choix, on applique différents filtres.
case $KoovAction in
"True")
echo "Nom du fichier d'icône       : "$ICON_FILE
case $Filter in

	### image simple,
    "IAI" | "ImageAsIcon")
		echo "Traitement                   : ImageAsIcon"
		# conservation de toute l'image, conservation du ratio,ajout d'un fond transparent
		montage -depth $COL_DEPTH "$IMAGE" -tile x1 -geometry '128x128+0+0' -background Transparent "$WRKDIR"/$ICON_FILE
		NEW_ICON=./$ICON_FILE
		
		echo "ImageAsIcone,       NEW_ICON : "$NEW_ICON
		echo "============================="
		
    ;;

	### image simple + icone dossier en miniature
    "FOI" | "FolderOverImage")
		echo "Traitement                   : FolderOverImage"
		echo "Icône de dossier par défaut  : "$icon_folder
		# conservation de toute l'image, conservation du ratio,ajout d'un fond transparent
		montage -depth $COL_DEPTH "$IMAGE" -tile x1 -geometry '128x128+0+0' -background Transparent "$TMPDIR"/.koov-tmp.png
		# réduction du dossier par défaut, 1/4 de l'icone finale
		convert -depth $COL_DEPTH "$icon_folder" -geometry 42x42 -format png "$TMPDIR"/.koov-tmpfolder.png
		
		# Ajout du mini dossier à droite
		#composite -depth $COL_DEPTH -compose src-over "$TMPDIR"/.koov-tmpfolder.png "$TMPDIR"/.koov-tmp.png -gravity SouthEast -format png -quality 95 "$WRKDIR"/$ICON_FILE
		
		# Ajout du mini dossier à gauche
		composite -depth $COL_DEPTH -compose src-over "$TMPDIR"/.koov-tmpfolder.png "$TMPDIR"/.koov-tmp.png -gravity SouthWest -format png -quality 95 "$WRKDIR"/$ICON_FILE
		
		NEW_ICON=./$ICON_FILE
		
		echo "FolderOverImage,    NEW_ICON : "$NEW_ICON
		echo "============================="
		
    ;;

	### image suit silhouette du dossier
	### TODO  faire apparaitre les contours du dossier en transparencce
    "FS" | "FolderShadow")
		echo "Traitement                   : FolderShadow"
		echo "Icône de dossier par défaut  : "$icon_folder
		convert -depth $COL_DEPTH "$IMAGE" -thumbnail x256 -resize '256x<' -resize 50% -gravity center -crop 128x128\+0+0 "$TMPDIR"/.koov-tmp.png
		composite -depth $COL_DEPTH -compose atop "$TMPDIR"/.koov-tmp.png "$icon_folder" -gravity center -format png -quality 95 "$WRKDIR"/$ICON_FILE
		
		NEW_ICON=./$ICON_FILE
		
		echo "FolderShadow,       NEW_ICON : "$NEW_ICON
		echo "============================="
		
    ;;

	###image en miniature sur le dossier
	### TODO mettre un crop transparent du dossier sur l'image
    "IOF" | "ImageOverFolder")
		echo "Traitement                   : ImageOverFolder"
		echo "Icône de dossier par défaut  : "$icon_folder
		# Petite image 1/2 de l'icône finale
		#convert -depth $COL_DEPTH "$IMAGE"  -resize x200 -resize '200x<' -resize 30% -gravity center -crop 80x80\+0+0 -bordercolor Transparent -border 1 "$TMPDIR"/.koov-tmp.png
		
		# Petite image 2/3 de l'icône finale
		#convert -depth $COL_DEPTH "$IMAGE"  -resize x200 -resize '200x<' -resize 40% -gravity center -crop 100x100\+0+0 -bordercolor Transparent -border 1 "$TMPDIR"/.koov-tmp.png
		
		# Petite image 4/5 de l'icône finale
		convert -depth $COL_DEPTH "$IMAGE"  -resize x200 -resize '200x<' -resize 45% -gravity center -crop 100x100\+0+0 -bordercolor Transparent -border 1 "$TMPDIR"/.koov-tmp.png
		
		# image placée en bas à gauche
		#composite -depth $COL_DEPTH -compose src-over "$TMPDIR"/.koov-tmp.png "$icon_folder" -gravity SouthWest -format png -quality 95 "$WRKDIR"/$ICON_FILE
		
		# image placée en bas à droite
		#composite -depth $COL_DEPTH -compose src-over "$TMPDIR"/.koov-tmp.png "$icon_folder" -gravity SouthEast -format png -quality 95 "$WRKDIR"/$ICON_FILE
		
		# image placée au milieu à droite
		#composite -depth $COL_DEPTH -compose src-over "$TMPDIR"/.koov-tmp.png "$icon_folder" -gravity East -format png -quality 95 "$WRKDIR"/$ICON_FILE
		
		# image placée au centre
		#composite -depth $COL_DEPTH -compose src-over "$TMPDIR"/.koov-tmp.png "$icon_folder" -gravity center -format png -quality 95 "$WRKDIR"/$ICON_FILE
		
		# image placée en Haut au milieu
		#composite -depth $COL_DEPTH -compose src-over "$TMPDIR"/.koov-tmp.png "$icon_folder" -gravity north -format png -quality 95 "$WRKDIR"/$ICON_FILE
		
		# image placée en Haut à droite
		composite -depth $COL_DEPTH -compose src-over "$TMPDIR"/.koov-tmp.png "$icon_folder" -gravity northeast -format png -quality 95 "$WRKDIR"/$ICON_FILE
		
		NEW_ICON=./$ICON_FILE
		
		echo "ImageOverFolder,    NEW_ICON : "$NEW_ICON
		echo "============================="
		
    ;;

	### impression photo-polaroid
    "P" | "Polaroid")
		echo "Traitement                   : Polaroid"
		convert -depth $COL_DEPTH "$IMAGE"  -resize 400x400 \
			-bordercolor white  -border 24 -bordercolor grey60 -border 4 \
			-background  none  -rotate `perl -e 'print rand() * 20 - 10'` -background black \
			\( +clone -shadow 60x8+12%+12% \) +swap \
			-background  transparent -flatten \
			-bordercolor transparent  -border 1 \
			-gravity NorthWest -crop 97% -resize 128x128 \
			-format png -quality 95 "$TMPDIR"/.koov-tmp.png
		
		montage -depth $COL_DEPTH "$TMPDIR"/.koov-tmp.png  -tile x1 -geometry '128x128+0+0' -background transparent "$WRKDIR"/$ICON_FILE
		
		NEW_ICON=./$ICON_FILE
		
		echo "Polaroid,           NEW_ICON : "$NEW_ICON
		echo "============================="
		
    ;;

	### Pile de photos polaroid
    "PS" | "PolaroidStack")
		echo "Traitement                   : PolaroidStack"
		
		convert -depth $COL_DEPTH "$IMAGE" -resize 400x400 \
			-bordercolor white  -border 24 -bordercolor grey60 -border 4 \
			-bordercolor none  -background  none \
			\( -clone 0  -rotate `perl -e 'print rand() * 30 - 15'` \) \
			\( -clone 0  -rotate `perl -e 'print rand() * 30 - 15'` \) \
			\( -clone 0  -rotate `perl -e 'print rand() * 30 - 15'` \) \
			\( -clone 0  -rotate `perl -e 'print rand() * 30 - 15'` \) \
			-delete 0  -border 400x320  -gravity center \
			-crop 800x640+0+0  +repage  -flatten -trim +repage \
			-background black \( +clone -shadow 60x8+12%+12% \) +swap \
			-background transparent -flatten \
			-gravity NorthWest -crop 97% -resize 128x128 \
		-format png -quality 95 "$TMPDIR"/.koov-tmp.png
		
		montage -depth $COL_DEPTH "$TMPDIR"/.koov-tmp.png  -tile x1 -geometry '128x128+0+0' -background transparent "$WRKDIR"/$ICON_FILE
		
		NEW_ICON=./$ICON_FILE
		
		echo "PolaroidStack       NEW_ICON : "$NEW_ICON
		echo "============================="
		
    ;;

	### marche mal, appel supprimé ds les services menus
    "P3" | "Polaroid3")
		echo "Traitement                   : 3Polaroids"
		convert -depth $COL_DEPTH "$IMAGE2" -thumbnail x200 -resize '150x' -resize 50% -gravity center -crop 100x100+0+0 "$TMPDIR"/.koov-tmp.png
		
		convert -depth $COL_DEPTH -size 150x150 xc:none -background none -fill white -stroke grey60 \
			-draw "rectangle 0,0 130,100" "$TMPDIR"/.koov-tmp1.png  \
				-geometry +5+5 -composite -rotate -10 \
			-draw "rectangle 0,0 130,100" "$TMPDIR"/.koov-tmp.png \
				-geometry +5+5 -composite -rotate -10 \
			-draw "rectangle 0,0 130,100" "$TMPDIR"/.koov-tmp1.png \
				-geometry +5+5 -composite -rotate +10 \
			-trim +repage -background transparent -flatten \
			-format png -quality 95 "$WRKDIR"/$ICON_FILE
		
		NEW_ICON=./$ICON_FILE
		
		echo "3Polaroids          NEW_ICON : "$NEW_ICON
		echo "============================="
		
    ;;

	### Retour au répertoire par défaut
    "STD" | "StandardFolder")
		echo "Traitement                   : StandardFolder"
		echo "Icône de dossier par défaut  : "$icon_folder
		NEW_ICON=folder.png
		
		echo "StandardFolder,     NEW_ICON : "$NEW_ICON
		echo "============================="
		
	;;

esac 
;;

"False")
	echo "KoovAction set to False      : Aucune icône n'a été créée"
	echo "============================="
	;;

esac


}


# ================================================================================================= Fonction Mise à jour du Fichier "pilote"
PILOT_FILE_MANAGEMENT ()
{
echo "Fonction                     : PILOT_FILE_MANAGEMENT"
echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
 ### BUG si .directory contient la ligne "Icon="
 ###     Une nouvelle ligne est créée au lieu de faire une mise à jour de la ligne existante !!!

# Mise à jour du fichier .directory ou création du fichier s'il existe
# Conserver la copie et la suppression des fichiers temporaires en local,
# sinon, en récursif, impossible de revenir en arrière en cas d'erreur !!!

case $KoovAction in
"True")
	if [[ -f "$WRKDIR"/.directory ]]
	then
		PREVIOUS_ICON="$(cat "$WRKDIR"/.directory | grep ^Icon= | cut -f2 -d'=' -s)"
		
		if [[ -n "$PREVIOUS_ICON" ]]
		then
			if [ "chk""$PREVIOUS_ICON" == "chk""$NEW_ICON" ]
			then
			# le nom de l'icône est identique, on ne fait rien
				echo "Icône précédante             : "$PREVIOUS_ICON
				echo "Nouvelle icône               : "$NEW_ICON
				echo "Fichier .directory           : à jour"
				echo "============================="
				
			else
			# Mise à jour de la ligne pré-existante
				echo "Icône précédante             : "$PREVIOUS_ICON
				echo "Nouvelle icône               : "$NEW_ICON
				echo "Mise à jour du fichier       : .directory"
				echo "ligne                        : Icon="$NEW_ICON
				echo "============================="
				
				touch "$WRKDIR"/.directory.sav
				cp "$WRKDIR"/.directory "$WRKDIR"/.directory.sav
				sed -e "s|$PREVIOUS_ICON|$NEW_ICON|g" <"$WRKDIR"/.directory.sav > "$WRKDIR"/.directory
				rm "$WRKDIR"/.directory.sav
			fi
			
		else
			echo "Icône précédante             : est vide " $PREVIOUS_ICON
			# recherche de la section [Desktop Entry]
			DESKTOP_ENTRY_SECTION="$(cat "$WRKDIR"/.directory | grep '^\[Desktop Entry\]')"
			
			if [[ -n "$DESKTOP_ENTRY_SECTION" ]]
			then
				echo "Mise à jour du fichier       : .directory"
				echo "Section DESKTOP              : "$DESKTOP_ENTRY_SECTION
				echo "Ajout de la ligne            : Icon="$NEW_ICON
				echo "============================="
				
				# [Desktop Entry]
				# Ajouter la ligne "Icon=...." juste en dessous de [Desktop Entry]
				touch "$WRKDIR"/.directory.sav
				cp "$WRKDIR"/.directory "$WRKDIR"/.directory.sav
				
				#Remplacer la ligne [Desktop Entry] par [Desktop Entry] CR Icon=$New_Icon
				sed -e "s|\[Desktop Entry\]|\[Desktop Entry\]\nIcon\=$NEW_ICON|" <"$WRKDIR"/.directory.sav > "$WRKDIR"/.directory
				
				rm "$WRKDIR"/.directory.sav
				
			else
				echo "Mise à jour du fichier       : .directory"
				echo "Section DESKTOP              : n'existe pas" $DESKTOP_ENTRY_SECTION
				echo "Ajout de la ligne            : [Desktop Entry]"
				echo "Ajout de la ligne            : Icon="$NEW_ICON
				echo "============================="
				
				# [Desktop Entry] n'existe pas
				# Ajouter les deux lignes en tête de fichier
				touch "$WRKDIR"/.directory.sav
				cp "$WRKDIR"/.directory "$WRKDIR"/.directory.sav
				
				sed -e "i\[Desktop Entry\]\nIcon\=$NEW_ICON" <"$WRKDIR"/.directory.sav > "$WRKDIR"/.directory
				
			fi
			
		fi 
		
	else
		# création du fichier
		echo "Création du fichier          : .directory"
		echo "Ajout de la ligne            : [Desktop Entry]"
		echo "Ajout de la ligne            : Icon="$NEW_ICON
		echo "============================="
		touch "$WRKDIR"/.directory
		echo "[Desktop Entry]" > "$WRKDIR"/.directory
		echo "Icon=$NEW_ICON" >> "$WRKDIR"/.directory
		
	fi
	;;

"False")
	echo "KoovAction set to False      : Rien n'a été fait"
	echo "============================="
	;;
	
esac


}


# ================================================================================================= Fonction Ménage
DIRECTORY_CLEANNER ()
{
echo "Fonction                     : DIRECTORY_CLEANNER"
echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
echo "                             : Recherche des fichiers temporaires"


# -------------------------------------------------------- Faire le ménage des fichiers temporaires
# code de sortie de ls si fichiers     trouvés = 0
# code de sortie de ls si fichiers non trouvés = 2
# pour verif du code de sortie, juste après le ls : echo "sortie " =$? 
if ls "$TMPDIR"/.koov-tmp* &> /dev/null
then	# code de sortie de ls = 0, des fichiers .koov-tmp existent
		#echo " code de sortie de ls si fichiers     trouvés 0"
		#echo "sortie de ls " =$?
	echo "                             : Effacement des fichiers temporaires"
	rm "$TMPDIR"/.koov-tmp*

else	# code de sortie de ls != 0, pas de fichiers .koov-tmp
		#echo " code de sortie de ls si fichiers non trouvés 2"
		#echo "sortie de ls " =$?
	echo "                             : Pas de fichier temporaire"
	
fi





# -------------------------------------------------------- Faire le ménage des fichiers log

# Si Création d'un Logfile demander si on le supprime ou non
# code de sortie de ls si fichiers     trouvés = 0
# code de sortie de ls si fichiers non trouvés = 2
# pour verif du code de sortie, juste après le ls : echo "sortie " =$? 
if ls "$WRKDIR"/KoovFolder*.log &> /dev/null
then
	Logfiles="True"
	LogInWrkDir="True"
fi

if ls "$STARTDIR"/KoovFolder*.log &> /dev/null
then
	Logfiles="True"
	LogInStartDir="True"
fi

if [[ -z "$Logfiles" ]]
then
	Logfiles="False"
fi	

case "$Logfiles" in
"True")
	echo "                             : Effacement du fichier log"
	
	if [[ "$forced_del_log" == "non" ]]
	then
		#kdialog oui / non del fichiers log
		DelLog_yn=`kdialog --caption Del Log --yesno "Effacer les fichiers log ?"`
		# Si yes
		if [[ $? = 0 ]]
		then
			DelLog="True"
		# Si no
		else
			DelLog="False"
		fi
	else
		DelLog="True"
	fi
	;;
	
"False")
	echo "                             : Pas de fichier log"
	;;
esac


case "$DelLog" in
"True")
	if [[ "$LogInStartDir" == "True" ]]
	then
		echo "Effacement des log dans      : "$STARTDIR
		rm "$STARTDIR"/KoovFolder*.log
	fi

	if [[ "$LogInWrkdirDir" == "True" ]]
	then
		echo "Effacement des log dans      : "$WRKDIR
		rm "$WRKDIR"/KoovFolder*.log
	fi
	;;
	
"False")
	echo "                             : Pas de fichier log"
	;;
esac

}





# =======================================================================================================================================
# =======================================================================================================================================
# DEBUT SCRIPT avec APPEL DE FONCTIONS ============================================================= DEBUT SCRIPT avec APPEL DE FONCTIONS
# =======================================================================================================================================
# =======================================================================================================================================

# Effacer l'ecran pour les affichages en console
clear
echo "============================="
echo "KoovFolder Version           : "$KoovRelease
echo "============================="

# Si appel sans aucun argument, afficher l'aide ou sortir
if [[ "$1" == "" ]]
then
	clear
	echo "Pas de variable entrée, affichage de l'aide ? (O/N)"
	read OorN
	clear
	
	case "$OorN" in
	"O" | "o" | "Y" | "y" )
		HELP_SECTION
		;;
	"N" | "n" )
		exit 0
		;;
	esac
fi

# les vavriables $1, $2, etc. ne sont pas vues par la fonction ARGUMENT_FILTERING,
# Transfert des $ dans des Var
Var1="$1" Var2="$2" Var3="$3" Var4="$4" Var5="$5"

# Tri et affectation des variables
ARGUMENT_FILTERING

# Vérification des variables dans le fichier de conf
READ_CONF

# ================================================================================================= Init des variables de travail

# Effacement Auto des Log
forced_del_log=$conf_read_del_log

# Nom du fichier icône généré
ICON_FILE=$conf_read_icon_file

#profondeur de couleur pour les outils imagemagick 
case "$conf_read_col_depth" in
Q8)
	COL_DEPTH=8
	;;

Q16)
	COL_DEPTH=16
	;;

esac


# Répertoire contenant l'icône du dossier par défaut
Default_folder_icon_path="$conf_read_icon_folder"

# Verif existance du répertoire
if [[ "$conf_read_icon_folder" != "default" ]]
then
	if ls "$conf_read_icon_folder"/128x128/filesystems &> /dev/null
	then	# code de sortie de ls = 0, commande OK
		echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
		echo "Répertoire filesystems       : "$conf_read_icon_folder
		echo "                             : Accessible"
		echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
	else	# code de sortie de ls != 0, commande échouée
		echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
		echo "Le Répertoire                : "$conf_read_icon_folder
		echo "                             : n'est pas un thème d'icônes"
		echo "$conf_read_icon_folder"/128x128/filesystems
		echo "                             : n'existe pas"
		echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
		KoovCanAct="False"
	fi

fi



# Répertoire de démarrage (nécessaire si mode récursif activé)
STARTDIR="$(pwd)"

# Répertoire des fichiers temporaires (peu être modifié, /tmp/Koov, etc... )
TMPDIR="$STARTDIR"
# ================================================================================================= FIN Init des variables de travail

# Recherche Icône de dossier par défaut, à ne faire qu'en cas de besoin
case $Filter in
"FOI"|"FolderOverImage"|"FS"|"FolderShadow"|"IOF"|"ImageOverFolder"|"STD"|"StandardFolder")
	DEFAULT_FOLDER_SEARCHING
	;;
	
esac

# Si le traitement n'est pas possible, sortir
 ### TODO Renforcer ce test. Existance du répertoire, de l'image
case "$KoovCanAct" in
"True")
	echo "Traitement Possible          : "$KoovCanAct
	echo "============================="
	;;
"False")
	echo "Traitement Impossible        : "$KoovCanAct
	echo "============================="
	echo "                             : Sortie du script"
	echo
	exit 0
	;;
esac


# ================================================================================================= Analyse InVar
# Répertoire ou Fichier image ?
ChkInVar="$STARTDIR"/"$InVar"

echo "DEBUG                        : Variables de Path et fichiers"
echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"

if [[ -a "$ChkInVar" ]]
then
	echo "Le fichier pointé par InVar  : Existe"
else
	echo "Le fichier pointé par InVar  : N'existe pas"
fi

if [[ -d "$ChkInVar" ]]
then
	WorkOn="Folder"
	WRKDIR="$STARTDIR"/"$InVar"
fi

if [[ -f "$ChkInVar" ]]
then
	WorkOn="File"
	WRKDIR="$STARTDIR"
fi


echo "                       InVar : "$InVar
echo "                    STARTDIR : "$STARTDIR

if [[ "$WorkOn" == "Folder" ]]
then
	echo "                      WorkOn : Folder : "$InVar

fi	

if [[ "$WorkOn" == "File" ]]
then
	echo "                      WorkOn : File : "$InVar

fi	

echo "                     WORKDIR : "$WRKDIR
echo "============================="
#pause_debug

# ================================================================================================= FIN Analyse InVar


# ================================================================================================= Gestion de la récursivité
case "$RecurseMode" in
"True")
	### ===============================================================================================================================
	### =================================================================================================== En cours de développement
	### ===============================================================================================================================
	
	echo "Mode de fonctionnement       : Traitement Récursif"
	echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
	
	# Répertoire de travail (le répertoire dans lequel on crée une icône, évolue en mode réursif)
	#WRKDIR="$STARTDIR"/"$InVar"
	
	# générer la liste des répertoires à traiter
	echo "                             : Génération de la liste des répertoires à traiter"
	ls -R "$InVar" | grep :$ > "$STARTDIR"/.koov-tmp_dirlist-1.txt
	
	# Adapter les lignes pour utilisation par le script
	echo "                             : Adaptation pour utilisation par le script"
	sed -e "s|:||g" < "$STARTDIR"/.koov-tmp_dirlist-1.txt > "$STARTDIR"/.koov-tmp_dirlist-2.txt
	
	# initialisation de la boucle while
	CompteurDeTraitement=0
	CompteurDeBoucle=1
	
	# mémoriser ligne 1 de "$STARTDIR"/.koov-tmp_dirlist-2.txt dans $WRKDIR
	ReadDir=$(head -1 "$STARTDIR"/.koov-tmp_dirlist-2.txt)
	
	# Tant que WRKDIR n'est pas vide ....
	# INFO:  ${#chaine} = Longueur de $chaine
	while [[ ${#ReadDir} > 0 ]]
	do
		WRKDIR="$STARTDIR"/"$ReadDir"
		
	### DEBUG
	#	echo "CompteurDeBoucle : "$CompteurDeBoucle
	#	echo "taille de ReadDir :"${#ReadDir}
	#	echo "WRKDIR : "$WRKDIR
	#	echo "fichier dirlist-2"
	#	echo "---------------------------------"
	#	cat "$STARTDIR"/.koov-tmp_dirlist-2.txt
	#	echo "---------------------------------"
	#	pause_debug
	### FIN DEBUG
		
		
		# supprimer 1ère ligne de "$STARTDIR"/.koov-tmp_dirlist-2.txt
		sed '1d' < "$STARTDIR"/.koov-tmp_dirlist-2.txt > "$STARTDIR"/.koov-tmp_dirlist-2bis.txt
		cp "$STARTDIR"/.koov-tmp_dirlist-2bis.txt "$STARTDIR"/.koov-tmp_dirlist-2.txt
		
		# vider la variable image de la boucle précédante
		IMAGE=
		
		# lancer Sélection image à traiter
		IMAGE_SELECTION
		
		# Si Image à traiter n'est pas vide ou null
		case "$KoovAction" in
		"False" )
			echo "Traitement Récursif          : Passe "$CompteurDeBoucle" - Pas d'image, Scanner répertoire suivant"
			echo "============================="
			
			;;
			
		"True" )
			echo "Traitement Récursif          : Passe "$CompteurDeBoucle" - Lancement du traitement Graphique"
			echo "============================="
			# incrementer compteur d'action
			let "CompteurDeTraitement+=1"
			
			# lancer Traitements Graphiques
			GRAPHIC_TREATMENTS
			# lancer Mise à jour du Fichier "pilote"
			PILOT_FILE_MANAGEMENT
			
			;;
			
		esac
		
		# Placer le test en fin de boucle, sinon, tourne une fois de trop, les compteurs sont faussés
		# mémoriser ligne 1 de "$STARTDIR"/.koov-tmp_dirlist-2.txt dans $WRKDIR
		ReadDir=$(head -1 "$STARTDIR"/.koov-tmp_dirlist-2.txt)
		
		# incrémenter le compteur pour le log
		let "CompteurDeBoucle+=1"
		
	done
	
	# Inscrire le nombre d'icônes crées dans le log
	let "CompteurDeBoucle-=1"
	echo "Traitement Récursif          : "$CompteurDeBoucle" répertoires scannés"
	
	# différent si STD ou autre
	case $Filter in
	"STD"|"StandardFolder" )
		echo "Traitement Récursif          : "$CompteurDeTraitement" icônes supprimées"
		;;
	* )	
		echo "Traitement Récursif          : "$CompteurDeTraitement" icônes crées"
		;;
	esac
	
	echo "============================="
	
		
	# lancer Ménage dans les fichiers temporaires
	DIRECTORY_CLEANNER
	# Sortir 
	;;
	
"False")
	echo "Mode de fonctionnement       : Traitement mono niveau"
	echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
	
	### BUG: Problème de STARTDIR / WORKDIR suivant sélection d'un répertoire ou d'une image
	###      Revoir le filtrage des variables
	#WRKDIR="$STARTDIR"/"$InVar"
	
	# lancer Sélection image à traiter
	IMAGE_SELECTION
	# lancer Traitements Graphiques
	GRAPHIC_TREATMENTS
	# lancer Mise à jour du Fichier "pilote"
	PILOT_FILE_MANAGEMENT
	# lancer Ménage dans les fichiers temporaires
	DIRECTORY_CLEANNER
	# Sortir 
	;;
	
esac


# Fin